﻿import flash.events.Event;
import flash.events.EventDispatcher;
import flash.events.MovieClipEventDispatcher;
import src.flash.display.Attacher;

/**
 * ...
 * @author k0t0vich
 */
class flash.display.DisplayObject extends Attacher
{
	public function DisplayObject($parent,linkageName) 
	{
		super($parent,linkageName);	
	}
	
	//------------------------------------------------
	private var _addedToStage:Boolean = false;
	
	public function get addedToStage():Boolean { return _addedToStage; }
	
	/**
	 * Положение в массиве childrenList родителя. ( ~ соотносится с глубиной)
	 */
	private var index:Number;
	
	private function removeFromStage():Void 
	{
		_addedToStage = false;
		mc._visible = false;
		dispatchRemovedFromStage();
	}
	private function addToStage():Void 
	{
		_addedToStage = true;
		visible = _visible;
		dispatchAddedToStage();
		//TODO: пройтись по всем детям и вызвать dispatchAddedToStage
	}
	
	public function dispatchRemovedFromStage():Void
	{
		dispatchEvent (new Event(Event.REMOVED_FROM_STAGE));
	}
	
	public function dispatchAddedToStage():Void
	{
		// диспатчим событие об удалении ( придумать как слать события о добавлении если добаляют родителя.. нверное из родителя вызывать )
		if (stage != null) dispatchEvent (new Event(Event.ADDED_TO_STAGE));
	}

	
	
	////////////////////////////AS3 методы ////////////////////////////////////////
	/// The Stage of the display object.
	public function get stage ():Object	{
		
		if (this._addedToStage)	
		{
			// если корневой мувик - возвращать рут.
			if (_parent instanceof MovieClip) 
				return _root;
			else
				return _parent.stage;
		}
		else
			return null;
	}
		
		private var _visible:Boolean = true;
		
		/// Whether or not the display object is visible.
		public function get visible () : Boolean		{return _visible;}	
		public function set visible (value:Boolean) : Void	{
			_visible = value;
			if (_addedToStage) mc._visible = value;
		}
	
		
		/// Indicates the alpha transparency value of the object specified.
		public function get alpha () : Number		{return mc._alpha;		}
		public function set alpha (value:Number) : Void		{ mc._alpha = value; }
		

		/// Indicates the width of the display object, in pixels.
		public function get width () : Number		{return mc._width;}
		public function set width (value:Number) : Void		{mc._width = value;	}

		/// Indicates the height of the display object, in pixels.
		public function get height () : Number		{return mc._height;	}
		public function set height (value:Number) : Void { mc._height = value;	}
		

		/// Indicates the x coordinate of the DisplayObject instance relative to the local coordinates of the parent DisplayObjectContainer.
		public function get x () : Number		{return mc._x;}
		public function set x (value:Number) : Void		{mc._x = value;}

		/// Indicates the y coordinate of the DisplayObject instance relative to the local coordinates of the parent DisplayObjectContainer.
		public function get y () : Number		{return mc._y;}
		public function set y (value:Number) : Void		{mc._y = value;}		
	
		/// Indicates the instance name of the DisplayObject.
		public function get name () : String		{return mc._name;}	
		public function set name (value:String) : Void	{mc._name = value;}
		
		
		/// An indexed array that contains each filter object currently associated with the display object.
		public function get filters () : Array		{return mc.filters;	}
		public function set filters (value:Array) : Void {	mc.filters = value;}
		
		/// Indicates the x coordinate of the mouse position, in pixels.
		public function get mouseX () : Number		{return mc._xmouse;}

		/// Indicates the y coordinate of the mouse position, in pixels.
		public function get mouseY () : Number	{return mc._ymouse;	}
		
		
		/// For a display object in a loaded SWF file, the root property is the top-most display object in the portion of the display list's tree structure represented by that SWF file.
		public function get root () { return _root;}

		/// Indicates the rotation of the DisplayObject instance, in degrees, from its original orientation.
		public function get rotation () : Number { return mc._rotation}
		public function set rotation (value:Number) : Void { mc._rotation = value;}

		/// Indicates the horizontal scale (percentage) of the object as applied from the registration point.
		public function get scaleX () : Number { return mc._xscale; }
		public function set scaleX (value:Number) : Void{ mc._xscale = value;}

		/// Indicates the vertical scale (percentage) of an object as applied from the registration point of the object.
		public function get scaleY () : Number{ return mc._yscale}
		public function set scaleY (value:Number) : Void { mc._yscale = value; }
		
		/*
		/// A value from the BlendMode class that specifies which blend mode to use.
		public function get blendMode () : String;
		public function set blendMode (value:String) : Void;

				/// The current scaling grid that is in effect.
		public function get scale9Grid () : Rectangle;
		public function set scale9Grid (innerRectangle:Rectangle) : Void;
		
		/// If set to true, Flash Player caches an internal bitmap representation of the display object.
		public function get cacheAsBitmap () : Boolean;
		public function set cacheAsBitmap (value:Boolean) : Void;

		/// Returns a LoaderInfo object containing information about loading the file to which this display object belongs.
		public function get loaderInfo () : LoaderInfo;

		/// The calling display object is masked by the specified mask object.
		public function get mask () : DisplayObject;
		public function set mask (value:DisplayObject) : Void;

		/// Specifies whether the display object is opaque with a certain background color.
		public function get opaqueBackground () : Object;
		public function set opaqueBackground (value:Object) : Void;


		/// The scroll rectangle bounds of the display object.
		public function get scrollRect () : Rectangle;
		public function set scrollRect (value:Rectangle) : Void;



		/// An object with properties pertaining to a display object's matrix, color transform, and pixel bounds.
		public function get transform () : Transform;
		public function set transform (value:Transform) : Void;

		/// Returns a rectangle that defines the area of the display object relative to the coordinate system of the targetCoordinateSpace object.
		public function getBounds (targetCoordinateSpace:DisplayObject) : Rectangle;

		/// Returns a rectangle that defines the boundary of the display object, based on the coordinate system defined by the targetCoordinateSpace parameter, excluding any strokes on shapes.
		public function getRect (targetCoordinateSpace:DisplayObject) : Rectangle;

		/// Converts the point object from Stage (global) coordinates to the display object's (local) coordinates.
		public function globalToLocal (point:Point) : Point;

		/// Evaluates the display object to see if it overlaps or intersects with the display object passed as a parameter.
		public function hitTestObject (obj:DisplayObject) : Boolean;

		/// Evaluates the display object to see if it overlaps or intersects with a point specified by x and y.
		public function hitTestPoint (x:Number, y:Number, shapeFlag:Boolean = false) : Boolean;

		/// Converts the point object from the display object's (local) coordinates to the Stage (global) coordinates.
		public function localToGlobal (point:Point) : Point;*/
}